double rndsph(double *v)
/* random vector in 1-sphere */
{
 double rr;
 do {
   v[0]=rndcos(); v[1]=rndcos(); v[2]=rndcos();
   } while ((rr=v[0]*v[0]+v[1]*v[1]+v[2]*v[2])>=1);
 return rr;
}

void rndonsph(double *v)
/* random unit vector */
{
 double rr;

 do {
   v[0]=rndcos(); v[1]=rndcos(); v[2]=rndcos();
   rr=v[0]*v[0]+v[1]*v[1]+v[2]*v[2];
   } while (rr>1 || rr<0.0625);
 rr=sqrt(rr);
 v[0]/=rr; v[1]/=rr; v[2]/=rr;
}

