/* normal Gaussian distribution, exact version */
/* directly #includable module */

double rndgauss(void)
{
  static unsigned phase;
  static double gauss2;

  if (phase++&1)
    return gauss2;
  else {
    double x=rndcos()*PI_DOUBLE,y=sqrt(-2*log(rnd()));
    gauss2=sin(x)*y;
    return cos(x)*y; }
}
