static FILE *lock;
static char *Fnarg1;

char *Fn(char *ext) /*************************************************** Fn */
{
 return string("%s.%s",Fnarg1,ext);
}

void removelock(void) /***************************************** removelock */
/*
  removes the lock file SIMNAME.loc
  registered by atexit() to be called on program exit() 
*/
{
 if (lock) fclose(lock);
 remove(Fn("loc"));
}

volatile int sig=0;
#include <signal.h>

void asksig(int signr) /* ========================================== asksig */
{
 if (sig) exit(-1); /* ^C typed twice */
 sig=signr;

/* refresh the ^C handler - nothing is compatible */
#ifdef __EMX__
 signal(signr,SIG_ACK);
#else /*# __EMX__ */
 signal(signr,asksig);
#endif /*# __EMX__ */
 fprintf(stderr,
         "\nINTERRUPT(%d) ACCEPTED, wait to finish or type ^C/SIGTERM again to kill\n",
         signr);
}

#ifdef NOCLOCK
typedef int clock_t;
#define CLOCKS_PER_SEC 1.

clock_t clock(void)
{
 time_t t;

 return time(&t);
}
#endif
