/*
  common header file for random number generators rndgen0.c, rndgen1.c, ...
*/

#include "int4.h"

extern char rndinfo[80];           /* info string */
unsigned4 rndinit(int4 tablen,int4 seed);/* returns max Irnd+1 */
unsigned4 Irnd(void);              /* function returning random integer upto max */
double rnd(void);                  /* random number in (0,1) */
unsigned4 irnd(unsigned4 n);       /* random number in {0,...,n-1} */
double rndcos(void);               /* random number in (-1,1) */

/* see rndetc.c: */
double rndsph(double *r);          /* random vector in 1-sphere */
double rnddisk(double *r);         /* random vector in 1-disk */
void rndonsph(double *v);          /* random vector on 1-sphere */
