typedef double z_f(double);

double corr(z_f Z,double rho)
{
 double d=1e-5,rp=rho+d,rm=rho-d;
 double zp=Z(PI/6*rp);
 double z0=Z(PI/6*rho);
 double zm=Z(PI/6*rm);
 double chi=(zp*rp-zm*rm)/(2*d);

 zp=(zp-1)*rp;
 zm=(zm-1)*rm;
 z0=(z0-1)*rho;

 return 0.5*rho*(zp+zm-2*z0)/Sqr(d)/chi;
}
